// List 2-1-3 XCb`𗣂Əiݒ~
// 2015/4/1 Wed Version 1.00
// Copyright (C) 2015 by Hiroyuki UCHIDA (Beard UCHIDA) JG1CCL (W3CCL)

// 錾
extern void main();                     // C֐
extern void init_port();                // o̓|[g֐
extern void init_timer();               // ^C}[֐
extern void led_on(int led);            // LEDn_֐
extern void led_off(int led);           // LEDn֐
extern void interrupt();                // 荞݊֐
extern unsigned seed;                   // ̔n

// `
#define INPUT_MODE  1                   // ̓[h
#define OUTPUT_MODE 0                   // o̓[h
#define FLAG_ON 1                       // XCb`tOFON
#define FLAG_OFF 0                      // XCb`tOFOFF

// |[gݒ
// LED0
sbit LED0           at PORTB.B0;        // LED0̓|[gBrbg0ɐڑ
sbit LED0_Direction at TRISB.B0;        // Direction
#define LED0_ON  LED0 = 1               // LED0_
#define LED0_OFF LED0 = 0               // LED0
// LED1
sbit LED1           at PORTB.B1;        // LED1̓|[gBrbg1ɐڑ
sbit LED1_Direction at TRISB.B1;        // Direction
#define LED1_ON  LED1 = 1               // LED1_
#define LED1_OFF LED1 = 0               // LED1
// LED2
sbit LED2           at PORTB.B2;        // LED2̓|[gBrbg2ɐڑ
sbit LED2_Direction at TRISB.B2;        // Direction
#define LED2_ON  LED2 = 1               // LED2_
#define LED2_OFF LED2 = 0               // LED2
// LED3
sbit LED3           at PORTB.B3;        // LED3̓|[gBrbg3ɐڑ
sbit LED3_Direction at TRISB.B3;        // Direction
#define LED3_ON  LED3 = 1               // LED3_
#define LED3_OFF LED3 = 0               // LED3
// LED4
sbit LED4           at PORTB.B4;        // LED4̓|[gBrbg4ɐڑ
sbit LED4_Direction at TRISB.B4;        // Direction
#define LED4_ON  LED4 = 1               // LED4_
#define LED4_OFF LED4 = 0               // LED4
// LED5
sbit LED5           at PORTB.B5;        // LED5̓|[gBrbg5ɐڑ
sbit LED5_Direction at TRISB.B5;        // Direction
#define LED5_ON  LED5 = 1               // LED5_
#define LED5_OFF LED5 = 0               // LED5
// LED6
sbit LED6           at PORTB.B6;        // LED6̓|[gBrbg6ɐڑ
sbit LED6_Direction at TRISB.B6;        // Direction
#define LED6_ON  LED6 = 1               // LED6_
#define LED6_OFF LED6 = 0               // LED6
// LED7
sbit LED7           at PORTB.B7;        // LED7̓|[gBrbg7ɐڑ
sbit LED7_Direction at TRISB.B7;        // Direction
#define LED7_ON  LED7 = 1               // LED7_
#define LED7_OFF LED7 = 0               // LED7
// LED8
sbit LED8           at PORTA.B2;        // LED8̓|[gArbg2ɐڑ
sbit LED8_Direction at TRISA.B2;        // Direction
#define LED8_ON  LED8 = 1               // LED8_
#define LED8_OFF LED8 = 0               // LED8
// LED9
sbit LED9           at PORTA.B4;        // LED9̓|[gArbg4ɐڑ
sbit LED9_Direction at TRISA.B4;        // Direction
#define LED9_ON  LED9 = 1               // LED9_
#define LED9_OFF LED9 = 0               // LED9

// XCb`
sbit SW           at PORTA.B5;          // XCb`̓|[gArbg5ɐڑ
sbit SW_Direction at TRISA.B5;          // Direction
#define SW_ON  Button(&PORTA, 5, 1, 1)  // XCb`ON
#define SW_OFF Button(&PORTA, 5, 1, 0)  // XCb`OFF

// `
// ϐ
unsigned seed = 0;                      // ̔nF0ɂ

// C֐
void main()
{
    // `
    // ϐ
    int led = 0;                        // LEDnFLED0ɂ
    int i;                              // JE^[
    int buttonFlag = FLAG_OFF;          // XCb`tOFOFFɂ

/* @Jn */
    // ݒ 16F1827 & 16F1847
    // OSCCON: OSCILLATOR CONTROL REGISTER
    // NbN8MHzɐݒ肷
    OSCCON = 0b01110000;

    // ANSELA: PORTA ANALOG SELECT REGISTER
    // fW^I/Oݒ肷
    ANSELA = 0b0000000;

    // ANSELB: PORTB ANALOG SELECT REGISTER
    // fW^I/Oݒ肷
    ANSELB = 0b00000000;

    init_port();                        // o̓|[g
    init_timer();                       // ^C}[
/* @I */

    // 荞݂
    INTCON.T0IE = 1;                    // ^C}[荞݂
    INTCON.GIE = 1;                     // O[o荞݂

    led_on(led);                        // LEDn_

    // JԂ
    while (1) {
        // XCb`Ƃɂ́A
        if (SW_ON) {
            buttonFlag = FLAG_ON;       // XCb`tOONɂ

            // 
            srand(seed);                // ^C}[𗘗p

            led_off(led);               // LEDn
            Delay_ms(100);              // 0.1b҂

            led++;                      // LEDnɂ
            // LED9zƂɂ́A
            if (led > 9) {
                led = 0;                // LED0ɂ
            }

            led_on(led);                // LEDn_
            Delay_ms(100);              // 0.1b҂

        // ȊOŁAXCb`𗣂Ƃɂ́A
        } else if (buttonFlag == FLAG_ON) {
            // JԂ
            for (i = 0; i < rand() % 6 + 5; i++) {
                led_off(led);           // LEDn
                Vdelay_ms(100 * i);     // 0.1~ib҂

                led++;                  // LEDnɂ
                // LED9zƂɂ́A
                   if (led > 9) {
                      led = 0;          // LED0ɂ
                }

                led_on(led);            // LEDn_
                Vdelay_ms(100 * i);     // 0.1~ib҂
            }
            buttonFlag = FLAG_OFF;      // XCb`tOOFFɂ
        }
    }
}

// o̓|[g
void init_port()
{
    LED0_Direction = OUTPUT_MODE;       // LED0o͂ɐݒ肷
    LED0_OFF;                           // LED0
    LED1_Direction = OUTPUT_MODE;       // LED1o͂ɐݒ肷
    LED1_OFF;                           // LED1
    LED2_Direction = OUTPUT_MODE;       // LED2o͂ɐݒ肷
    LED2_OFF;                           // LED2
    LED3_Direction = OUTPUT_MODE;       // LED3o͂ɐݒ肷
    LED3_OFF;                           // LED3
    LED4_Direction = OUTPUT_MODE;       // LED4o͂ɐݒ肷
    LED4_OFF;                           // LED4
    LED5_Direction = OUTPUT_MODE;       // LED5o͂ɐݒ肷
    LED5_OFF;                           // LED5
    LED6_Direction = OUTPUT_MODE;       // LED6o͂ɐݒ肷
    LED6_OFF;                           // LED6
    LED7_Direction = OUTPUT_MODE;       // LED7o͂ɐݒ肷
    LED7_OFF;                           // LED7
    LED8_Direction = OUTPUT_MODE;       // LED8o͂ɐݒ肷
    LED8_OFF;                           // LED8
    LED9_Direction = OUTPUT_MODE;       // LED9o͂ɐݒ肷
    LED9_OFF;                           // LED9

    SW_Direction  = INPUT_MODE;         // XCb`͂ɐݒ肷
}

// ^C}[
void init_timer()
{
        //TIMER0̐ݒ
        OPTION_REG.T0CS = 0;            // NbNgp
        OPTION_REG.PSA = 0;             // vXP[[gp
        OPTION_REG.PS0 = 0;             // [g1/2ɐݒ肷
        OPTION_REG.PS1 = 0;
        OPTION_REG.PS2 = 0;
}

// LEDn_
// ́FLEDn
void led_on(int led)
{
    // LEDA
    switch (led) {
        // LED0̂Ƃɂ́A
        case 0:
            LED0_ON;                    // LED0_
            break;
        // LED1̂Ƃɂ́A
        case 1:
            LED1_ON;                    // LED1_
            break;
        // LED2̂Ƃɂ́A
        case 2:
            LED2_ON;                    // LED2_
            break;
        // LED3̂Ƃɂ́A
        case 3:
            LED3_ON;                    // LED3
            break;
        // LED4̂Ƃɂ́A
        case 4:
            LED4_ON;                    // LED4_
            break;
        // LED5̂Ƃɂ́A
        case 5:
            LED5_ON;                    // LED5_
            break;
        // LED6̂Ƃɂ́A
        case 6:
            LED6_ON;                    // LED6_
            break;
        // LED7̂Ƃɂ́A
        case 7:
            LED7_ON;                    // LED7_
            break;
        // LED8̂Ƃɂ́A
        case 8:
            LED8_ON;                    // LED8_
            break;
        // LED9̂Ƃɂ́A
        case 9:
            LED9_ON;                    // LED9_
            break;
    }
}

//  LEDn
// ́FLEDn
void led_off(int led)
{
    // LEDA
    switch (led) {
        // LED0̂Ƃɂ́A
        case 0:
            LED0_OFF;                   // LED0
            break;
        // LED1̂Ƃɂ́A
        case 1:
            LED1_OFF;                   // LED1
            break;
        // LED2̂Ƃɂ́A
        case 2:
            LED2_OFF;                   // LED2
            break;
        // LED3̂Ƃɂ́A
        case 3:
            LED3_OFF;                   // LED3
            break;
        // LED4̂Ƃɂ́A
        case 4:
            LED4_OFF;                   // LED4
            break;
        // LED5̂Ƃɂ́A
        case 5:
            LED5_OFF;                   // LED5
            break;
        // LED6̂Ƃɂ́A
        case 6:
            LED6_OFF;                   // LED6
            break;
        // LED7̂Ƃɂ́A
        case 7:
            LED7_OFF;                   // LED7
            break;
        // LED8̂Ƃɂ́A
        case 8:
            LED8_OFF;                   // LED8
            break;
        // LED9̂Ƃɂ́A
        case 9:
            LED9_OFF;                   // LED9
            break;
    }
}

// 荞ݏ
void interrupt()
{
    // TIMER0̊荞݂̂Ƃɂ́A
    if (INTCON.T0IF == 1) {
        INTCON.T0IF = 0;                // I[o[t[tONA[
        seed++;                         // ̔nJEg
    }
}
// End