// List 2-2-1 ボタンを押したときに点灯する
// 2015/4/1 Wed Version 1.00
// Copyright (C) 2015 by Hiroyuki UCHIDA (Beard UCHIDA) JG1CCL (W3CCL)

// ピン設定
const int LED_PIN = 4;     // LED0はデジタルピン4に接続する
const int BUTTON_PIN = 2;  // プッシュボタンはデジタルピン2に接続する

// 変数
int buttonState = LOW;     // プッシュボタンの状態：LOWにする

void setup() {
  pinMode(LED_PIN, OUTPUT);    // LED0を出力に設定する
  pinMode(BUTTON_PIN, INPUT);  // プッシュボタンを入力に設定する
}

void loop(){
  buttonState = digitalRead(BUTTON_PIN);  //  プッシュボタンの状態を読む

  // ボタンを押したときには、
  if (buttonState == HIGH) {
    digitalWrite(LED_PIN, HIGH);  // LED0を点灯する

  // それ以外のときには、
  } else {
    digitalWrite(LED_PIN, LOW);   // LED0を消灯する
  }
}
